<template>
    <div class="setting-cheatsheet">
        <el-form label-position="top">
            <el-form-item :label="label.payment.list.alipay" prop="payment_alipay">
                <el-switch v-model="form.payment.alipay"></el-switch> <span style="margin-left: 1rem">{{alipayStatus}}</span>
            </el-form-item>
            <el-form-item :label="label.payment.list.wechat" prop="payment_wechat">
                <el-switch v-model="form.payment.wechat"></el-switch> <span style="margin-left: 1rem">{{wechatStatus}}</span>
            </el-form-item>
            <el-form-item :label="label.seller.head" prop="seller">
                <div>
                    <el-table :data="data.seller" style="width:100%">
                            <el-table-column
                                :label="label.seller.table.rank"
                                fixed
                            >
                                <template slot-scope="scope">
                                    <span style="margin-left: 10px">{{ scope.row.rank }}</span>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller.table.auto_confirm_order"
                            >
                                <template slot-scope="scope">
                                    <el-input 
                                        v-model="scope.row.auto_confirm_order" 
                                    ></el-input>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller.table.auto_release_payment"
                            >
                                <template slot-scope="scope">
                                    <el-input 
                                        v-model="scope.row.auto_release_payment" 
                                    ></el-input>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller.table.action"
                            >
                                <template slot-scope="scope">
                                    <el-button @click="setSellerSetting(scope.row)" type="success">{{label.seller.button.save}}</el-button>
                                </template>
                            </el-table-column>
                    </el-table>
                </div>
            </el-form-item>
            <el-form-item :label="label.seller_topup.head" prop="seller_topup_rank">
                <div>
                    <el-form ref="form_seller_topup" :model="form.seller_topup">
                        <el-form-item :label="label.seller_topup.form.current_rank">
                            <el-input v-model="form.seller_topup.current_rank"></el-input>
                        </el-form-item>
                        <el-form-item :label="label.seller_topup.form.rank_id">
                            <el-input v-model="form.seller_topup.rank_id"></el-input>
                        </el-form-item>
                        <el-form-item :label="label.seller_topup.form.amount">
                            <el-input v-model="form.seller_topup.amount"></el-input>
                        </el-form-item>
                        <el-form-item :label="label.seller_topup.form.message">
                            <el-input v-model="form.seller_topup.message"></el-input>
                        </el-form-item>
                        <el-form-item style="margin-top:0.5rem">
                            <el-button type="primary" @click="addSellerTopUpSetting">{{label.seller_topup.button.save}}</el-button>
                        </el-form-item>
                    </el-form>
                </div>
                <div>
                    <el-table 
                        :data="data.seller_topup" 
                        style="width:100%"
                        :span-method="splitByCurrentRank"
                    >
                            <el-table-column
                                :label="label.seller_topup.table.current_rank"
                                fixed
                            >
                                <template slot-scope="scope">
                                    <span style="margin-left: 10px">{{ scope.row.current_rank }}</span>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller_topup.table.destination_rank"
                                fixed
                            >
                                <template slot-scope="scope">
                                    <el-input 
                                        v-model="scope.row.rank_id" 
                                    ></el-input>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller_topup.table.amount"
                                fixed
                            >
                                <template slot-scope="scope">
                                    <el-input 
                                        v-model="scope.row.amount" 
                                    ></el-input>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller_topup.table.message"
                                fixed
                            >
                                <template slot-scope="scope">
                                    <el-input 
                                        v-model="scope.row.message" 
                                    ></el-input>
                                </template>
                            </el-table-column>
                            <el-table-column
                                :label="label.seller_topup.table.action"
                            >
                                <template slot-scope="scope">
                                    <el-button @click="editSellerTopUpSetting(scope.row)" type="success">{{label.seller_topup.button.save}}</el-button>
                                    <el-button @click="deleteSellerTopUpSetting(scope.row)" type="danger">{{label.seller_topup.button.delete}}</el-button>
                                </template>
                            </el-table-column>
                    </el-table>
                </div>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'setting',
    data() {
        return {
            initData: true,
            form: {
                payment: {
                    wechat: false,
                    alipay: false,
                },
                seller_topup: {
                    current_rank: 0,
                    rank_id: 1,
                    amount: 0,
                    message: '',
                },
            },
            label: {
                payment: {
                    list: {
                        alipay: 'Alipay payment Status',
                        wechat: 'Wechatpay payment Status',
                    }
                },
                seller: {
                    head: 'Seller Setting',
                    table: {
                        rank: 'Rank',
                        auto_confirm_order: 'Auto Confirm Order (in minutes)',
                        auto_release_payment: 'Auto release payment (in minutes)',
                        action: 'Action'
                    },
                    button: {
                        detail: 'Detail',
                        save: 'Save Setting'
                    },
                },
                boolean: {
                    active: 'Active',
                    nonactive: 'Non Active',
                },
                seller_topup: {
                    head: 'Seller Top Up Table',
                    table: {
                        current_rank: 'Current Rank',
                        destination_rank: 'Destination Rank',
                        amount: 'Amount needed',
                        message: 'Message when seller top up',
                        action: 'Action'
                    },
                    form: {
                        current_rank: 'Current Rank',
                        rank_id: 'Destination Rank',
                        amount: 'Amount needed',
                        message: 'Message when seller top up',
                    },
                    button: {
                        save: 'Save',
                        delete: 'Delete',
                    }
                }
            },
            data: {
                seller: null,
                seller_topup: [],
            }
        }
    },
    computed: {
        alipayStatus() {
            if (this.form.payment.alipay === true) {
                return this.label.boolean.active
            }
            return this.label.boolean.nonactive
        },
        wechatStatus() {
            if (this.form.payment.wechat === true) {
                return this.label.boolean.active
            }
            return this.label.boolean.nonactive
        }

    },
    watch: {
        'form.payment.alipay' (newVal,oldVal) {
            this.setPayment('alipay',newVal)
        },
        'form.payment.wechat' (newVal,oldVal) {
            this.setPayment('wechat',newVal)
        }
    },
    created() {
        this.init()
        setTimeout(() => {
            this.initData = false
        }, 1000);
    },
    methods: {
        init() {
            this.getPaymentSetting()
            this.getSellerSetting()
            this.getSellerTopupSetting()
        },
        setPayment(paymentType, value) {
            let data = {
                pay_type: paymentType,
                value: value
            }
            this.m_api.cheatsheet_set_payment(data).then((res) => {
                if (!this.initData && res.data == 1) {
                    this.m_success("Success change "+paymentType+" status");                    
                }
            }).catch((err) => {
                this.m_warning("Error happen when edit payment status")
            })
        },
        getPaymentSetting() {
            this.m_api.cheatsheet_get_payment().then((res) => {
                res.data.forEach(item => {
                    if (item.key && item.key.toLowerCase() === 'alipay') {
                        this.form.payment.alipay = item.value
                    }
                    if (item.key && item.key.toLowerCase() === 'wechat') {
                        this.form.payment.wechat = item.value
                    }
                });
            })
        },
        getSellerSetting() {
            this.m_api.cheatsheet_get_seller().then((res) => {
                this.data.seller = res.data
            })
        },
        setSellerSetting(row) {
            Object.entries(row).forEach(([column,value]) => {
                if (column.toLowerCase() !== 'rank') {
                    let data = {
                        rank: row.rank,
                        column: column,
                        value: value
                    }
                    this.m_api.cheatsheet_set_seller(data).then((res) => {
                        this.m_success("Success change rank "+row.rank+" setting of "+column);
                    }).catch((err) => {
                        this.m_warning("Error happen when edit seller setting")
                    })
                }
            })
        },
        getSellerTopupSetting() {
            this.m_api.cheatsheet_get_topup_lists().then((res) => {
                if (res.data.length > 0) {
                    res.data.forEach(element => {
                        Object.keys(element.lists).forEach((key) => {
                            let data = element.lists[key]
                            data.current_rank = element.current_rank
                            this.data.seller_topup.push(data)
                        })
                    });
                }
            })
        },
        splitByCurrentRank({ row, column, rowIndex, columnIndex }) {
            // skip it for now, idk how to split it xD
        },
        editSellerTopUpSetting(row) {
            this.m_api.cheatsheet_set_topup_lists(row).then((res) => {
                this.m_success("Success change top up value");
            }).catch((err) => {
                this.m_warning("Error happen when edit seller top up setting")
            });
        },
        deleteSellerTopUpSetting(row) {
            this.m_api.cheatsheet_delete_topup_lists(row).then((res) => {
                this.m_success("Success delete top up value");
            }).catch((err) => {
                this.m_warning("Error happen when edit seller top up setting")
            });
        },
        addSellerTopUpSetting() {
            this.editSellerTopUpSetting(this.form.seller_topup)
        }
    }
}
</script>